/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*
 * $Author: wenming.wu $
 * $Date: 2015/10/21 $
 * $RCSfile: drv_dvi.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/
/**
 * @file dvi2com driver interface
 *
 * @author wenming_wu@mtk.com.tw
 */

#ifndef _DRV_DVI2COM_H_
#define _DRV_DVI2COM_H_

#include "typedef.h"
extern void vCCIR2SetAvStart(UINT8 u1Type,UINT16 wStart);

extern void vCCIR2SetAvWidth(UINT8 u1Type,UINT16 wWidth);

extern void vCCIR2SetVsStart(UINT8 u1Type,UINT16 wStart);

extern void vCCIR2SetVdeWidth(UINT8 u1Type,UINT16 wWidth);

extern void vCCIR2Set422To444(UINT8 u1Type,BOOL fgIs422);

extern UINT16 wCCIR2GetAvStart(UINT8 u1Type);

extern UINT16 wCCIR2GetAvWidth(UINT8 u1Type);

extern UINT16 wCCIR2GetVsStart(UINT8 u1Type);

extern UINT16 wCCIR2GetVdeWidth(UINT8 u1Type);

extern UINT8 bCCIR2CENStatus(UINT8 u1Type);

extern UINT8 bCCIR2ClkStatus(UINT8 u1Type);

extern void vCCIR2SetCENSel(UINT8 u1Type,UINT8 u1CenSel);

extern void vCCIR2SetClkDiv(UINT8 u1Type,UINT8 u1ClkDiv);

extern BOOL bCCIR2IsDownSample(UINT8 u1Type);

extern void vCCIR2SetDownSample(UINT8 u1Type, UINT8 u1CenSel, UINT8 u1ClkDiv);

extern void vCCIR2Set3DVactive(UINT8 u1Type, UINT32 u4Value);

extern void vCCIR2Set3DVactiveSP1(UINT8 u1Type, UINT32 u4Value);

extern void vCCIR2Set3DVactiveSP2(UINT8 u1Type, UINT32 u4Value);

extern void vCCIR2DecoderInitial(UINT8 u1Type);

extern void vOmuxPatternGenOnOff(UINT8 bPath, UINT8 bMode);

extern void vCCIR2GetStatus(UINT8 bchannel);

extern void vCCIR2SetInterlace(UINT8 bchannel,BOOL fgInterlace);

extern void vCCIR2Set3DConfig(UINT8 u1Type,UINT8 u13DType);

#endif

