/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 *
 * $Author: wenming.wu $
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_HDMI14ANA_H_
#define _DRV_HDMI14ANA_H_

#include "typedef.h"

typedef enum
{
	HDMI14_TMDS_CLOCK_UNKNOW,
	HDMI14_TMDS_CLOCK_25,
	HDMI14_TMDS_CLOCK_25_35,
	HDMI14_TMDS_CLOCK_35_40,
	HDMI14_TMDS_CLOCK_40_50,
	HDMI14_TMDS_CLOCK_50_80,
	HDMI14_TMDS_CLOCK_80_100,
	HDMI14_TMDS_CLOCK_100_120,
	HDMI14_TMDS_CLOCK_120_140,
	HDMI14_TMDS_CLOCK_140_160,
	HDMI14_TMDS_CLOCK_160_200,
	HDMI14_TMDS_CLOCK_200_300
}Hdmi14TmdsClkRate_t;

typedef struct
{
	UINT8 u1CH0;
	UINT8 u1CH1;
	UINT8 u1CH2;
}HDMI14EQ_CODE;

typedef struct
{
	HDMI14EQ_CODE tEqCode;
	BOOL bEqTracking;
}HDMI14ANA_CONTROL;

typedef struct
{
	UINT8 _bKPGain;
	UINT8 _bRXMode;
	UINT8 _bEQGain;
	UINT8 _bVRef;
}HDMI14ANA_CONFIG;

extern void vHDMI14GetAnaConfig(Hdmi14TmdsClkRate_t eTmdsClk,HDMI14ANA_CONFIG *ptAna14Config);

extern void vHDMI14AnaInit(HdmiRxPort ePort);

extern void vHDMI14AnaTermCtrl(HdmiRxPort ePort,BOOL bOnOff);

extern void vHDMI14AnaTMDSCtrl(HdmiRxPort ePort, BOOL bOnOff);

extern void vHDMI14AnaPhyReset(HdmiRxPort ePort);

extern void vHDMI14AnaPhyBandCtrl(HdmiRxPort ePort,Hdmi14TmdsClkRate_t eTmdsClk);

extern void vHDMI14AnaPLLReset(HdmiRxPort ePort);

extern void vHDMI14AnaData_RST(HdmiRxPort ePort,UINT8 u1Rst); //Set 1(reset) before digital phy reset,  set 0(release) after digital phy reset

extern void vHDMI14AnaSetEqTracking(HdmiRxPort ePort,BOOL bTracking);

extern BOOL bIsHDMI14AnaEqTracking(HdmiRxPort ePort);

extern void vHDMI14AnaEQTracking(HdmiRxPort ePort);
#endif

