#ifndef _CEC2_IF_H_ /* added by George.yang */
#define _CEC2_IF_H_


#include "x_typedef.h"

// *********************************************************************
// constant define
// *********************************************************************
#define CEC2_RegOffset  0x80
#define CEC2_MAX_SEND_BUF  32
#define CEC2_MAX_REC_BUF   32

// *********************************************************************
// Type definitions
// *********************************************************************
typedef struct _CEC_HEADER_BLOCK{
	UINT8 destination : 4;
	UINT8 initiator   : 4;
} CEC_HEADER_BLOCK_t;

typedef struct _CEC_FRAME_BLOCK{
	CEC_HEADER_BLOCK_t header;
	UINT8 opcode;
	UINT8 operand[16];  
} CEC_FRAME_BLOCK_t;

typedef struct _CEC_FRAME_DESCRIPTION{
	UINT8 size; // Actual frame block size.  the max 16 = header + opcode + oprand 
	UINT8 sendidx;
	UINT8 reTXcnt;
	void* txtag;
	CEC_FRAME_BLOCK_t blocks;
} CEC_FRAME_DESCRIPTION_t;

typedef struct _CEC_DEVICE{
//		UINT8   stCECDevice;
	UINT8   fgCEC;
	UINT8   CECLogAdd;
	UINT32  RegOffset;
}CEC_DEVICE_t;
// ***********************************************************************
// Function Declaration
// ***********************************************************************
void CEC2_Init(void);

UINT8 CEC2_Tx_Enqueue(CEC_FRAME_DESCRIPTION_t *pf);
UINT8 CEC2_Rx_Enqueue(CEC_FRAME_DESCRIPTION_t *pf);
//	void _CEC2_TestCmd(UINT8 cmd);

#endif /* _CEC2_H_ */

