#ifndef _DRV_DOLBY_DRVIF_H_
#define _DRV_DOLBY_DRVIF_H_

#include "x_typedef.h"



#define  DOLBY_VIDEO_INFO       1
#define  DOLBY_METADATA_INFO    2

#define BITSTREAM_BUFFER_SIZE          (1024)     
#define Rpu_Buffer_Array_Idx_MAX          (8)
#define Rpu_Buffer_Debug_Array_Idx_MAX          (1000)



#define  DOLBY_RUN_MODE_MASK         3
    #define OTT_MODE                 (0)
    #define HDMI_HD_MODE             (1<<1)
    #define BYPASS_MODE              (1)
    #define HDMI_UHD_MODE            (3)
#define  DOLBY_Opt_MODE_MASK         (3<<2)
    #define BL_EL_RATIO11            (1<<2)
    #define BL_EL_RATIO41            (3<<2)
#define  DOLBY_GRAPHIC_MASK          (1<<5)
    #define GRAPHIC_DISABLE          (0<<5)
    #define GRAPHIC_ENABLE           (1<<5)
#define  DOLBY_PIXEL_RATE_MASK       (0xf<<6)
    #define PIXEL_RATE_23_98         (0<<6)
    #define PIXEL_RATE_24            (1<<6)
    #define PIXEL_RATE_25            (2<<6)
    #define PIXEL_RATE_29_97         (3<<6)
    #define PIXEL_RATE_30            (4<<6)
    #define PIXEL_RATE_50            (5<<6)
    #define PIXEL_RATE_59_94         (6<<6)
    #define PIXEL_RATE_60            (7<<6)
    
#define DOLBY_METADATA_DEBUG_OTT      0x1
#define DOLBY_METADATA_DEBUG_RPU      0x2
#define DOLBY_METADATA_DEBUG_DM_COMP  0x4
#define DOLBY_VERIFICATION            0x8
#define DOLBY_DEBUG_REG_LUT           0x10
#define DOLBY_DEBUG_CRC               0x20
//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
typedef struct dolby_cli_param_s {
    int frame_num;
    int width ;
    int height;
    char cFileNm[128];
} dolby_cli_param_t;

/** Brief of DOLBY_MSG_T
 */

typedef struct
{
    UINT32 u4Arg1;
    UINT32   u4Arg2;
    UINT32 u4Arg3;
    UINT32 u4Arg4;
    UINT32 u4Arg5;
} DOLBY_MSG_T;

typedef struct
{
    UINT8 u1VdpId;
    UINT8 u1Dolby_Mode;
    UINT8 u1Omux_Source;
} DOLBY_SRC_T;

typedef struct 
{
    UINT32 Dolby_Out_Y_Crc;
    UINT32 Dolby_Out_U_Crc;
    UINT32 Dolby_Out_V_Crc;
    UINT32 Dolby_IN_Y_Crc;
    UINT32 Dolby_IN_U_Crc;
    UINT32 Dolby_IN_V_Crc;
    
    UINT32 LUT_3D_Crc;
    UINT32 TC_Crc;
    UINT32 DM_Crc;
    UINT32 BL_Crc;
    UINT32 EL_Crc;
    UINT32 COMP_Crc;
    UINT32 COMP_420_Crc;

    UINT32 MIB_SRCW_CRC_OUT_V;
    UINT32 MIB_OUT_CRC_OUT_V;

    UINT32 frame_nr;
    //Pre-proc CRC
    
}DBY_CRC_T;
typedef struct 
{
    UINT32 u4Runmode;
    UINT32 u4Optmode;
    UINT32 u4Graphicmode;
    UINT32 u4PixelRate;
    UINT32 u4MetadataProgramErrorEnable;

    UINT32 u4DolbyMode;
    UINT32 u4Dolby_Dma_Vysnc_Mode;
    UINT32 u4Dolby_Dma_Hsync_mode;
    UINT32 u4Dolby_ClkEn;

    UINT32 u4Dolby_3D_Num;
    UINT32 u4Dolby_Tc_Num;
    UINT32 u4Dolby_3D_Addr;
    UINT32 u4Dolby_Tc_Addr;

    UINT32 u4Dolby_Sel444;
    UINT32 u4Dolby_Yc2Yuc_En;

    UINT32 dm_ret;
    UINT32 u4BLWidth;
    UINT32 u4BLHeight;
    
}DBY_PRM_T;

typedef struct
{
    UINT8 u4IsDoviHDR;
}DBY_CUSTOM_SOURCE_INFO_T;

EXTERN void vSetfgDolbyLoop(void);
EXTERN void vEnableDebugFlag(UINT32 bDebugFlag);
EXTERN void vDolbyMLInit(void);
EXTERN VOID vDolby_SendEvent(DOLBY_MSG_T tMsg);
EXTERN VOID vDrvDolbySetSource(DOLBY_SRC_T tSrc);
EXTERN void vDrv_Dolby_Destroy(void);
EXTERN void vDrv_DolbyChkCrc(void);
EXTERN void vDrv_DolbyOutputCrc(void);
EXTERN INT32 vDrv_GetDoviHDRInfo(UCHAR ucVdpId,  void* pkvPqGetInfo, UINT32 u4Size);
EXTERN VOID vDrvDolbySetCustSourceInfo(UINT8 bIsDoviHDR);
EXTERN void vDrv_Dolby_Uninit(void);
EXTERN void vDolby_Resume(void);
EXTERN void vDolby_Suspend(void);
EXTERN void vDolby_Info_Query(void);
EXTERN void vDrv_DolbyRpuBufferArrayReset(void);
EXTERN void vDolbyDumpRpuToFile(char *psDumpFileName);

#endif

